package com.css.simulation.resource.scheduler.mapper;

import com.css.simulation.resource.scheduler.pojo.po.CameraPO;
import org.apache.ibatis.annotations.*;
import org.apache.ibatis.type.JdbcType;

import java.util.List;

@Mapper
public interface SensorCameraMapper {

    @Results(id = "camera", value = {
            @Result(column = "name", property = "sensor_name", jdbcType = JdbcType.VARCHAR),
            @Result(column = "horizontal_field_angle", property = "sensor_fovH", jdbcType = JdbcType.DECIMAL),
            @Result(column = "vertical_field_angle", property = "sensor_fovV", jdbcType = JdbcType.DECIMAL),
            @Result(column = "blind_zone_distance", property = "sensor_near", jdbcType = JdbcType.DECIMAL),
            @Result(column = "detection_distance", property = "sensor_far", jdbcType = JdbcType.DECIMAL),
            @Result(column = "resolution", property = "sensor_resolution", jdbcType = JdbcType.DECIMAL),
            @Result(column = "frame_rate", property = "sensor_frameRate", jdbcType = JdbcType.DECIMAL),
            @Result(column = "sensor_x", property = "sensor_x", jdbcType = JdbcType.DECIMAL),
            @Result(column = "sensor_y", property = "sensor_y", jdbcType = JdbcType.DECIMAL),
            @Result(column = "sensor_z", property = "sensor_z", jdbcType = JdbcType.DECIMAL),
            @Result(column = "sensor_h", property = "sensor_h", jdbcType = JdbcType.DECIMAL),
            @Result(column = "sensor_p", property = "sensor_p", jdbcType = JdbcType.DECIMAL),
            @Result(column = "sensor_r", property = "sensor_r", jdbcType = JdbcType.DECIMAL),
    })
    @Select("select msc.name,\n" +
            "       msc.horizontal_field_angle,\n" +
            "       msc.vertical_field_angle,\n" +
            "       msc.blind_zone_distance,\n" +
            "       msc.detection_distance,\n" +
            "       msc.resolution,\n" +
            "       msc.frame_rate,\n" +
            "       rvs.sensor_x,\n" +
            "       rvs.sensor_y,\n" +
            "       rvs.sensor_z,\n" +
            "       rvs.sensor_h,\n" +
            "       rvs.sensor_p,\n" +
            "       rvs.sensor_r\n" +
            "from model_sensor_camera msc left join relation_vehicle_sensor rvs on msc.id = rvs.sensor_id\n" +
            "where msc.is_deleted = '0' and rvs.is_deleted = '0'" +
            "   and rvs.vehicle_id = #{vehicleId}")
    List<CameraPO> selectCameraByVehicleId(@Param("vehicleId") String vehicleId);
}
