package com.css.simulation.resource.project.enums;

import lombok.Getter;

/**
 * 项目评测等级枚举
 */
@Getter
public enum  EvaluationLevelEnum {

    G("10","G"),
    A("20","A"),
    M("30","M"),
    P("30","P");

    private String code;

    private String state;

    EvaluationLevelEnum(String code, String state){
        this.code = code;
        this.state = state;
    }

    public static String getState(String code){
        if(code == null){
            return "";
        }
        for(EvaluationLevelEnum e :  EvaluationLevelEnum.values()){
            if(e.code.equals(code)){
                return e.state;
            }
        }
        return "";
    }
}
