package com.css.simulation.resource.project.mapper;

import api.common.pojo.param.project.ProjectTaskParam;
import api.common.pojo.param.project.SceneScoreParam;
import api.common.pojo.param.project.SimulationManualProjectParam;
import api.common.pojo.po.project.*;
import api.common.pojo.vo.project.*;
import org.apache.ibatis.annotations.Mapper;
import org.springframework.stereotype.Repository;

import java.util.List;

@Mapper
@Repository
public interface SimulationProjectMapper {

    int add(SimulationManualProjectPo po);

    int update(SimulationManualProjectPo po);

    SimulationManualProjectPo selectLastProjectId(Integer nowRq);

    List<SimulationManualProjectPo> selectProject(SimulationManualProjectParam param);

    List<SimulationManualProjectVo> selectProjectList(SimulationManualProjectParam param);

    SimulationManualProjectPo selectProjectById(SimulationManualProjectParam param);

    List<SimulationManualProjectPo> selectProjectByName(SimulationManualProjectParam param);

    SimulationManualProjectPo selectProjectBaseById(SimulationManualProjectParam param);

    int deleteProject(String[] ids);

    int updateProjectNowRunState(SimulationManualProjectParam param);

    List<AlgorithmBaseInfoVo> selectAlgorithmBaseInfoById(String id);

    List<VehicleBaseInfoVo> selectVehicleBaseInfoById(String id);

    List<ScenePackageBaseVo> selectScenePackageBaseById(String id);

    List<VehicleSensorVo> selectVehicleSensor(String id);

    SensorBaseInfoVo selectSensorCamera(String id);

    SensorBaseInfoVo selectSensorOgt(String id);

    SensorBaseInfoVo selectSensorLidar(String id);

    SensorBaseInfoVo selectSensorRadar(String id);

    SensorBaseInfoVo selectSensorGps(String id);

    SceneBaseInfoVo selectSceneAccidentById(String id);

    SceneBaseInfoVo selectSceneNatural(String id);

    SceneBaseInfoVo selectSceneStandardsRegulations(String id);

    List<ManualProjectTaskPo> selectprojectTaskByQuery(ProjectTaskParam vo);

    List<ProjectRunStateNumVo> selectRunStateCount(String id);

    List<ProjectRunResultRatioNumVo> selectRunResultCount(String id);

    List<ScenePackageSubListVO> selectSubSceneByPid(String id);

    List<ScenePackageSubListVO> selectSubListByPid(String id);

    int insertSimulationMptLastTargetScorePo(SimulationMptLastTargetScorePo po);

    int insertSimulationMptSceneScorePo(SimulationMptSceneScorePo po);

    int insertSimulationMptFirstTargetScorePo(SimulationMptFirstTargetScorePo po);

    SimulationMptLastTargetScorePo selectLastTargetScore(SimulationMptLastTargetScorePo po);

    SimulationMptFirstTargetScorePo selectFirstTargetScore(SimulationMptFirstTargetScorePo po);

    SimulationMptSceneScorePo selectSceneScore(SimulationMptSceneScorePo po);

    List<SceneScoreVo> selectSceneScoreByIds(SceneScoreParam param);

    SceneScoreVo selectSceneScoreNumQuery(SimulationMptSceneScorePo po);

    SystemUserVo selectUserById(String id);

    List<ConfigVehicleVO> selectConfigVehicle(String id);

    List<ConfigSensorVo> selectConfigSensor(String id);

    List<SimulationManualProjectPo> selectProjectNowRunState(String[] ids);

}
