package com.css.simulation.resource.scene.ctrl;

import api.common.pojo.common.ResponseBodyVO;
import api.common.pojo.param.MinioParameter;
import api.common.pojo.param.scene.StandardsRegulationsParam;
import api.common.pojo.po.scene.StandardsRegulationsPO;
import api.common.pojo.vo.scene.StandardsRegulationsVO;
import api.common.util.FileUtil;
import com.css.simulation.resource.common.utils.PageUtil;
import com.css.simulation.resource.feign.FileDownService;
import com.css.simulation.resource.scene.service.StandardsRegulationsService;
import com.github.pagehelper.PageInfo;
import feign.Response;
import org.springframework.beans.BeanUtils;
import org.springframework.http.MediaType;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;

//标准法规
@RestController
@RequestMapping("/StandardsRegulations")
public class StandardsRegulationsController {

    @Resource
    StandardsRegulationsService standardsRegulationsService;

//查询列表
    @PostMapping("/queryStandardsRegulationsList")
    @ResponseBody
    public ResponseBodyVO<List<StandardsRegulationsVO>> queryStandardsRegulationsList(@RequestBody StandardsRegulationsParam parms) {
        PageUtil.setPageInfo(parms);
        List<StandardsRegulationsPO> list=standardsRegulationsService.querySceneNaturalList(parms);
        PageInfo<StandardsRegulationsPO> objectPageInfo = new PageInfo<>(list);
        List<StandardsRegulationsVO> list1=new ArrayList<>();
        for (StandardsRegulationsPO po: list) {
            StandardsRegulationsVO vo=new StandardsRegulationsVO();
            BeanUtils.copyProperties(po,vo);
            list1.add(vo);
        }
        PageInfo pageInfo=new PageInfo<>(list1);
        pageInfo.setTotal(objectPageInfo.getTotal());
        return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS,pageInfo);
    }


    //新增标准法规
    @PostMapping("/saveStandardsRegulations")
    @ResponseBody
    public ResponseBodyVO<String> saveStandardsRegulations(@RequestBody StandardsRegulationsParam parms) {
        standardsRegulationsService.importBzFg(parms);
        return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS);
    }

    @Resource
    private FileDownService fileDownService;

    @PostMapping(value = "/upload", consumes = MediaType.MULTIPART_FORM_DATA_VALUE)
    public ResponseBodyVO<String> upload(@RequestPart("file") MultipartFile file,
                                         @RequestParam("objectName") String objectName) {
        System.out.println("上传文件名称--------"+file.getOriginalFilename());
        return fileDownService.upload(file,file.getOriginalFilename());
    }

@PostMapping(value = "/download")
    public void download(
            HttpServletResponse response,@RequestBody @Validated MinioParameter parms
    ) throws IOException {
        Response download = fileDownService.download(parms);
        Response.Body body = download.body();
        InputStream inputStream = body.asInputStream();
        FileUtil.downloadForHttp(parms.getObjectName(), inputStream, response, 1024);
    }

}